﻿


import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Pyramide_Grf extends JFrame implements ActionListener {


private final int MAX_WIDTH=1000;
private final int MAX_HEIGHT=600;

private final int TIMER_STEP=100;
private final int MAX=10; 

  JPanel  canvas = new JPanel();  // Zeichenflaeche
  Timer timer;  
 
  Kasten k1,k2,k3;
  int anz=0;
  Font font = new Font("Arial", Font.BOLD, 24);

  public Pyramide_Grf() {
     setSize(MAX_WIDTH, MAX_HEIGHT);
      setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );  // damit schliesst man das Programm
      setLayout( new BorderLayout());  // einfaches Layout setzen
      add(canvas, BorderLayout.CENTER);  // Zeichenflaeche einfuegen
      canvas.setBackground(Color.WHITE);       
      setup();  // init des Programms
      timer = new Timer(100, this);  // in ms
      timer.start();  // starten
  }

  
      // wird vom Timer aufgerufen, muss nur einmal aufgerufen werden
      // ohne kracht es
  public void actionPerformed(ActionEvent e) {
    System.out.println("actionPerfomred" );
    calcPyramide(MAX);
    timer.stop();
  }  // actionperformed



      private void setup() {
        int w=getWidth()/16;
        int y=getHeight()-80;
        k1 = new Kasten("A",w*3,    y, w<<2, getHeight()-200, Color.RED, new Color(150,0,0) );
        k2 = new Kasten("B",w*3+5*w,y, w<<2, getHeight()-200, Color.GREEN, new Color(0,150,0));
        k3 = new Kasten("C",w*3+10*w,y, w<<2, getHeight()-200, Color.BLUE, new Color(0,0,150));        
      } // setup

      
      void calcPyramide(int n) {
          Ebene e;
          int w=k1.getWidth();
          int diff=w/(n+1);
          int h=k1.getHeight() / ((n)<<1);
          for (int i=n; i>0; i--) {
            e = new Ebene(w, h );
            System.out.println("w:"+w+"  h: "+h);
            k1.addEbene(e);
            w = w -diff;            
          }
          draw();
          time();
          anz=0;
          bewege(n, k1, k2, k3);
      }

      void bewege (int i, Kasten a, Kasten b, Kasten c) {
         // hier fehlt Code

              // hier fehlt Rekursion
              //anz++;
              //drawMove(a,c);  // verschieben zeichnen
              //draw();  // Ebene ist auf Zielpunkt
              time();
              // hier fehlt Rekursion
              
          }
      }
      
       // interne Methode
      private void drawMove(Kasten a, Kasten b) {
        Graphics g = canvas.getGraphics() ;
        Ebene ebene = a.removeEbene();
        draw();
        ebene.draw(g, a.getColor1(), a.getX(), 100);
        time();
        
        draw();
        ebene.draw(g, b.getColor1(), b.getX(), 100);
        time();
        b.addEbene(ebene);
      }
      
       // interne Methode
      private void draw() {
          Graphics g = canvas.getGraphics() ;
          g.setColor( Color.WHITE );
          g.fillRect(0,0, this.getWidth(), this.getHeight());
          g.setColor(Color.BLUE);
          g.setFont(   font  );
          String bez = "Die Pyramide des Inka-Königs";
          FontMetrics fontMetrics = g.getFontMetrics( g.getFont()  );
          int breite = fontMetrics.stringWidth(bez);
          g.drawString(bez, (getWidth()>>1)-(breite>>1), 40);
          k1.draw(g);
          k2.draw(g);
          k3.draw(g);
          g.drawString(anz+"",getWidth()>>1, 160);
      }
      

      
      
      private void time() {
        try {
          Thread.sleep(TIMER_STEP);
        } catch (InterruptedException ex) {
          Logger.getLogger(Pyramide_Grf.class.getName()).log(Level.SEVERE, null, ex);
        }
      }
                
    
        
     
  public static void main(String[] args) {
    Pyramide_Grf frame = new Pyramide_Grf();
    frame.setVisible(true);
 }

}  // Pyramide_Grf



